signature SFIFO where {
import ConfigReg;
		   
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import List;
	      
import Monad;
	       
import RWire;
	       
interface (SFIFO.SFIFO :: * -> * -> *) alpha_T search_T = {
    SFIFO.enq :: alpha_T -> Prelude.Action {-# arg_names = [x] #-};
    SFIFO.deq :: Prelude.Action {-# arg_names = [] #-};
    SFIFO.first :: alpha_T {-# arg_names = [] #-};
    SFIFO.clear :: Prelude.Action {-# arg_names = [] #-};
    SFIFO.find :: search_T -> Prelude.Bool {-# arg_names = [x] #-};
    SFIFO.find2 :: search_T -> Prelude.Bool {-# arg_names = [x] #-}
};
 
instance SFIFO (Prelude.PrimMakeUndefined alpha_T) =>
	       Prelude.PrimMakeUndefined (SFIFO.SFIFO alpha_T search_T);
									     
instance SFIFO (Prelude.PrimDeepSeqCond alpha_T) =>
	       Prelude.PrimDeepSeqCond (SFIFO.SFIFO alpha_T search_T);
									   
instance SFIFO (Prelude.PrimMakeUninitialized alpha_T) =>
	       Prelude.PrimMakeUninitialized (SFIFO.SFIFO alpha_T search_T);
										 
SFIFO.mkSFIFO :: (Prelude.Bits alpha_T asz, Prelude.IsModule _m__ _c__) =>
		 (search_T -> alpha_T -> Prelude.Bool) -> _m__ (SFIFO.SFIFO alpha_T search_T);
												   
SFIFO.mkSFIFO1 :: (Prelude.Eq alpha_T,
		   Prelude.Bits alpha_T asz,
		   Prelude.IsModule _m__ _c__) =>
		  (search_T -> alpha_T -> Prelude.Bool) -> _m__ (SFIFO.SFIFO alpha_T search_T);
												    
SFIFO.mkSizedSFIFOInternal :: (Prelude.Bits alpha_T alpha_SZ,
			       Prelude.IsModule _m__ _c__) =>
			      Prelude.Integer ->
			      (search_T -> alpha_T -> Prelude.Bool) ->
			      (search_T -> alpha_T -> Prelude.Bool) -> _m__ (SFIFO.SFIFO alpha_T search_T);
														
SFIFO.mkSizedSFIFO :: (Prelude.Bits alpha_T asz, Prelude.IsModule _m__ _c__) =>
		      Prelude.Integer ->
		      (search_T -> alpha_T -> Prelude.Bool) -> _m__ (SFIFO.SFIFO alpha_T search_T)
}
